import os

AGE_INDEX = 4
AGE_AVERAGE = 29.55
AGE_MINIMUM = 0.42
AGE_MAXIMUM = 99


def is_float(value):
    try:
        float(value)
        return True
    except ValueError:
        return False


def is_age_valid(record):
    # your implementation here
    return True


def clean_data(file_name):
    cleaned_records = list()
    with open(file_name) as file_handle:
        for row in file_handle:
            if is_age_valid(row):
                cleaned_records.append(row)

    return cleaned_records


def replace_missing_data(substitute, data):
    replaced_data = list()
    # Your implementation here

    return replaced_data


def text_histogram_age(hist):
    keys = ["0-9", "10-19", "20-29", "30-39", "40-49", "50-59", "60-69", "70-79", "80-89", "90-99"]
    for key in keys:
        if len(key) < 5:
            row_hist = " " + key + " : "
        else:
            row_hist = key + ": "
        for x in range(0, hist[key] / 4):
            row_hist += "#"
        row_hist += str(hist[key])
        print(row_hist)


def histogram_age(data):
    histogram = {"0-9": 0, "10-19": 0, "20-29": 0, "30-39": 0, "40-49": 0,
                 "50-59": 0, "60-69": 0, "70-79": 0, "80-89": 0, "90-99": 0}
    # Your implementation here
    return histogram


if __name__ == '__main__':
    # this code is only run when the script is executed, e.g. via: python task_xx_x.py
    data_file_name = os.path.join("..", "data", "titanic.csv")
    cleaned_data = clean_data(data_file_name)

    # if you were not able to write clean_data, then uncomment the following lines:
    # cleaned_data = list()
    # with open("..\data\cleaned_titanic.csv") as file_handle:
    #         for line in file_handle:
    #             cleaned_data.append(line)
    print("Distribution of cleaned data without replacing missing values:")
    print(histogram_age(cleaned_data))
    text_histogram_age(histogram_age(cleaned_data))
    print("Distribution of cleaned data after replacing missing values with mean:")
    replaced_cleaned_data = replace_missing_data(AGE_AVERAGE, cleaned_data)
    print(histogram_age(replaced_cleaned_data))
    text_histogram_age(histogram_age(replaced_cleaned_data))
    print("Distribution of cleaned data after replacing missing values with minimum:")
    replaced_cleaned_data = replace_missing_data(AGE_MINIMUM, cleaned_data)
    print(histogram_age(replaced_cleaned_data))
    text_histogram_age(histogram_age(replaced_cleaned_data))
    print("Distribution of cleaned data after replacing missing values with maximum:")
    replaced_cleaned_data = replace_missing_data(AGE_MAXIMUM, cleaned_data)
    print(histogram_age(replaced_cleaned_data))
    text_histogram_age(histogram_age(replaced_cleaned_data))
